from BaseHTTPServer import (
    HTTPServer,
    BaseHTTPRequestHandler,
    )
import contextlib
import os
from StringIO import StringIO
from unittest import TestCase

from grackle import client


def fake_grackle_service():
    pid = os.fork()
    if pid != 0:
        return pid
    service = HTTPServer(('', 8435), BaseHTTPRequestHandler)
    service.handle_request()
    os._exit(0)


class TestPutMessage(TestCase):

    def test_put_message(self):
        service = fake_grackle_service()
        client.put_message('arch1', StringIO('This is a message'))
